/*
 * Copyright (C) 2004 Andres Sajo
 *
 * This file is part of the nisperod package.
 *
 * nisperod is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA
 *
 *
 * $Id: clists.c,v 1.8 2004/10/08 14:31:24 andres Exp andres $ 
 */
 
#include "nisperod.h"

struct nispero_t * nisl_st = NULL;
struct def_tab_t * defl_st = NULL;

struct nispero_t * create_nispero_t_elem(struct nispero_t * follow){
	struct nispero_t * tmp = NULL;
	tmp = (struct nispero_t *)malloc(sizeof(struct nispero_t));
	if (tmp == NULL){
		perror("malloc");
		return NULL;
	}
	tmp->name[0] = '\0';
	tmp->c_id = 0;
	tmp->next = follow;
	return tmp;
}

struct def_tab_t * create_def_tab_elem(struct def_tab_t * follow){
	struct def_tab_t * tmp = NULL;
	/*printf("creating def_tab_t elem.\n");*/
	tmp = (struct def_tab_t *)malloc(sizeof(struct def_tab_t));
	if (tmp == NULL){
		perror("malloc");
		return NULL;
	}
	tmp->name[0] = '\0';
	tmp->cid[0] = '\0';
	tmp->tag = FALSE;
	tmp->next = follow;
	return tmp;
}

struct nispero_t * destroy_nispero_t_elem(struct nispero_t * elem){
	free(elem);
	return NULL;
}

struct def_tab_t * destroy_def_tab_elem(struct def_tab_t * elem){
	/*printf("destroying def_tab_t elem.\n"); */
	free(elem);
	return NULL;
}

struct nispero_t * seek_device(char * s, struct nispero_t * list){
	struct nispero_t * l;
	l = list;
	while (l != NULL){
		/* printf("%s == %s\n", s, l->name); */
		if (strcmp(s, l->name) == 0)
			return l;
		l = l->next;
	}
	return NULL;
}

struct def_tab_t * seek_def(char * s, struct def_tab_t * list){
	struct def_tab_t * l;
	l = list;
	while (l != NULL){
		/* printf("%s == %s\n", s, l->name); */
		if (strcmp(s, l->name) == 0)
			return l;
		l = l->next;
	}
	return NULL;
}

struct def_tab_t * seek_cid(char * s, struct def_tab_t * list){
	struct def_tab_t * l;
	l = list;
	while (l != NULL){
		/* printf("%s == %s\n", s, l->cid); */
		if (strcmp(s, l->cid) == 0)
			return l;
		l = l->next;
	}
	return NULL;
}
